/*
 * Created on 03-May-2004
 * 
 * (c) 2003-2005 ThoughtWorks Ltd
 *
 * See license.txt for license details
 */
package com.thoughtworks.proxy.factory;

import com.thoughtworks.proxy.Invoker;


/**
 * Interface to access the {@link Invoker} of the proxy. Every proxy generated by ProxyToys implements this interface.
 * 
 * @author Aslak Helles&oslash;y
 * @since 0.1
 */
public interface InvokerReference {
    /**
     * Rertrieve the Invoker instance from the proxy.
     * 
     * @return the {@link Invoker} instance.
     * @since 0.1
     */
    Invoker getInvoker();
}